=== source/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # CodeRED Makefile
 #
 
-# Start of configurable options.
+# Start of configurable options (boolean vars can be set to "yes" or "no").
 
 # Which compiler to use.
 CC?=gcc
@@ -19,11 +19,15 @@
 # Path to X libraries (e.g. GL).
 X11BASE?=/usr/X11R6
 
-# Build binary that uses SDL for sound when "1".
-SDLSOUND?=1
-
-# Selects the component to build; ALL, GAME, or DEDICATED
+# Selects the component to build: ALL, CLIENT, or DEDICATED
 BUILD?=ALL
+
+# Build binary that uses SDL for sound (when BUILD is "ALL" or "CLIENT").
+SDLSOUND?=yes
+
+# Adds DATADIR/LIBDIR (see below) to the data and library search path.
+WITH_DATADIR?=no
+WITH_LIBDIR?=no
 
 # End of configurable options.
 
@@ -51,13 +55,26 @@
 	_LIB := lib
 endif
 
-BASE_CFLAGS=$(CFLAGS) -Dstricmp=strcasecmp -D_stricmp=strcasecmp -I$(X11BASE)/include -fno-strict-aliasing -fmerge-constants
+BASE_CFLAGS=$(CFLAGS) -Dstricmp=strcasecmp -D_stricmp=strcasecmp -I$(X11BASE)/include -fno-strict-aliasing -fmerge-constants -DHAVE_CURL
+
+# DATADIR / LIBDIR support.
+
+PREFIX?=/usr/local
+
+ifeq ($(strip $(WITH_DATADIR)),yes)
+DATADIR?=$(PREFIX)/share/alienarena
+BASE_CFLAGS+=-DDATADIR='\"$(DATADIR)\"'
+endif
+
+ifeq ($(strip $(WITH_LIBDIR)),yes)
+LIBDIR?=$(PREFIX)/lib/alienarena
+BASE_CFLAGS+=-DLIBDIR='\"$(LIBDIR)\"'
+endif
 
 RELEASE_CFLAGS=$(BASE_CFLAGS)
 
 ifeq ($(strip $(OPTIMIZED_CFLAGS)),yes)
-RELEASE_CFLAGS+=-O$(OPTIM_LVL) -fomit-frame-pointer \
-		-ftree-vectorize -fexpensive-optimizations
+RELEASE_CFLAGS+=-O$(OPTIM_LVL) -fomit-frame-pointer -fexpensive-optimizations
 
 ifeq ($(OSTYPE),linux)
 ifeq ($(ARCH),x86_64)
@@ -82,10 +99,6 @@
 endif
 endif
 
-ifeq ($(shell curl -V | grep -c .), 3)
-	BASE_CFLAGS += -DHAVE_CURL
-endif
-
 ARENA_CFLAGS=-DARENA
 
 DEBUG_CFLAGS=$(BASE_CFLAGS) -g -ggdb
@@ -93,7 +106,7 @@
 LDFLAGS+=-lm
 # In FreeBSD, dlopen() is in libc.
 ifeq ($(OSTYPE),linux)
-	LDFLAGS+=-ldl
+LDFLAGS+=-ldl
 endif
 
 GLXLDFLAGS=-L$(X11BASE)/$(_LIB) -L$(LOCALBASE)/$(_LIB) -lX11 -lXext -lXxf86dga -lXxf86vm -lm -ljpeg -lGL -lGLU
@@ -109,7 +122,6 @@
 CURLLDFLAGS=$(shell curl-config --libs)
 
 JPEGLDFLAGS=-ljpeg
-PNGLDFLAGS=-lpng
 
 DO_CC=$(CC) $(CFLAGS) -o $@ -c $<
 DO_DEBUG_CC=$(CC) $(DEBUG_CFLAGS) -o $@ -c $<
@@ -138,16 +150,16 @@
 		$(BUILDDIR)/crx
 endif
 
+ifeq ($(strip $(BUILD)),CLIENT)
+	TARGETS+=$(BUILDDIR)/crx
+endif
+
 ifeq ($(strip $(BUILD)),DEDICATED)
-	SDLSOUND=0
+	SDLSOUND=no
 	TARGETS+=$(BUILDDIR)/crded
 endif
 
-ifeq ($(strip $(BUILD)),GAME)
-	TARGETS+=$(BUILDDIR)/crx
-endif
-
-ifeq ($(strip $(SDLSOUND)),1)
+ifeq ($(strip $(SDLSOUND)),yes)
 	TARGETS+=$(BUILDDIR)/crx.sdl
 endif
 
@@ -259,10 +271,10 @@
 	$(BUILDDIR)/client/snd_mixa.o
 
 $(BUILDDIR)/crx : $(CODERED_OBJS) $(SOUND_OSS_OBJS) $(CODERED_AS_OBJS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS)
-	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_OSS_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(CURLLDFLAGS) $(PNGLDFLAGS) $(JPEGLDFLAGS)
+	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_OSS_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(CURLLDFLAGS) $(JPEGLDFLAGS)
 
 $(BUILDDIR)/crx.sdl : $(CODERED_OBJS) $(SOUND_SDL_OBJS) $(CODERED_AS_OBJS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS)
-	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_SDL_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(SDLLDFLAGS) $(CURLLDFLAGS) $(PNGLDFLAGS) $(JPEGLDFLAGS)
+	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_SDL_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(SDLLDFLAGS) $(CURLLDFLAGS) $(JPEGLDFLAGS)
 
 $(BUILDDIR)/client/cl_cin.o :     $(CLIENT_DIR)/cl_cin.c
 	$(DO_CC)
@@ -458,16 +470,3 @@
 
 #############################################################################
 # DEDICATED SERVER
-#############################################################################
-
-CRDED_OBJS = \
-	\
-	$(BUILDDIR)/ded/cmd.o \
-	$(BUILDDIR)/ded/cmodel.o \
-	$(BUILDDIR)/ded/common.o \
-	$(BUILDDIR)/ded/crc.o \
-	$(BUILDDIR)/ded/cvar.o \
-	$(BUILDDIR)/ded/files.o \
-	$(BUILDDIR)/ded/mdfour.o \
-	$(BUILDDIR)/ded/net_chan.o \
-	\
