## alien-arena 7.33

=== source/Makefile ===
--- 
+++ 
@@ -21,9 +21,6 @@
 
 # Selects the component to build: ALL, CLIENT, or DEDICATED
 BUILD?=ALL
-
-# Build binary that uses SDL for sound (when BUILD is "ALL" or "CLIENT").
-SDLSOUND?=yes
 
 # Adds DATADIR/LIBDIR (see below) to the data and library search path.
 WITH_DATADIR?=no
@@ -55,7 +52,7 @@
 	_LIB := lib
 endif
 
-BASE_CFLAGS=$(CFLAGS) -Dstricmp=strcasecmp -D_stricmp=strcasecmp -I$(X11BASE)/include -fno-strict-aliasing -fmerge-constants -DHAVE_CURL
+BASE_CFLAGS=$(CFLAGS) -Dstricmp=strcasecmp -D_stricmp=strcasecmp -I$(X11BASE)/include -fno-strict-aliasing -fmerge-constants -DHAVE_CURL -lpthread
 
 # DATADIR / LIBDIR support.
 
@@ -74,7 +71,7 @@
 RELEASE_CFLAGS=$(BASE_CFLAGS)
 
 ifeq ($(strip $(OPTIMIZED_CFLAGS)),yes)
-RELEASE_CFLAGS+=-O$(OPTIM_LVL) -fomit-frame-pointer -fexpensive-optimizations
+RELEASE_CFLAGS+=-O$(OPTIM_LVL) -fomit-frame-pointer -fexpensive-optimizations -ffast-math
 
 ifeq ($(OSTYPE),linux)
 ifeq ($(ARCH),x86_64)
@@ -111,13 +108,15 @@
 
 GLXLDFLAGS=-L$(X11BASE)/$(_LIB) -L$(LOCALBASE)/$(_LIB) -lX11 -lXext -lXxf86dga -lXxf86vm -lm -ljpeg -lGL -lGLU
 
-SDLCFLAGS=$(shell sdl-config --cflags)
-SDLLDFLAGS=$(shell sdl-config --libs)
-
 SHLIBEXT=so
 SHLIBCFLAGS=-fPIC
 SHLIBLDFLAGS=-shared
 
+OPPENALCFLAGS+=$(shell pkg-config --cflags openal)
+
+VORBISCFLAGS+=$(shell pkg-config --cflags vorbisfile)
+VORBISLDFLAGS=$(shell pkg-config --libs vorbisfile)
+
 CURLCFLAGS=$(shell curl-config --cflags)
 CURLLDFLAGS=$(shell curl-config --libs)
 
@@ -126,7 +125,7 @@
 DO_CC=$(CC) $(CFLAGS) -o $@ -c $<
 DO_DEBUG_CC=$(CC) $(DEBUG_CFLAGS) -o $@ -c $<
 DO_DED_CC=$(CC) $(CFLAGS) -DDEDICATED_ONLY -o $@ -c $<
-DO_DED_DEBUG_CC=$(CC) $(DEBUG_CFLAGS) -DDEDICATED_ONLY -o $@ -c $<
+DO_DED_DEBUG_CC=$(CC) $(DEBUG_CFLAGS) -DDEDICATED_ONLY -DBUFFER_DEBUG -o $@ -c $<
 DO_O_CC=$(CC) $(CFLAGS) -O -o $@ -c $<
 DO_SHLIB_CC=$(CC) $(CFLAGS) $(SHLIBCFLAGS) -o $@ -c $<
 DO_SHLIB_O_CC=$(CC) $(CFLAGS) -O $(SHLIBCFLAGS) -o $@ -c $<
@@ -136,6 +135,7 @@
 DO_AS=$(CC) $(CFLAGS) -DELF -x assembler-with-cpp -o $@ -c $<
 DO_SHLIB_AS=$(CC) $(CFLAGS) $(SHLIBCFLAGS) -DELF -x assembler-with-cpp -o $@ -c $<
 
+
 DO_ARENA_SHLIB_CC=$(CC) $(CFLAGS) $(ARENA_CFLAGS) $(SHLIBCFLAGS) -o $@ -c $<
 
 #############################################################################
@@ -157,10 +157,6 @@
 ifeq ($(strip $(BUILD)),DEDICATED)
 	SDLSOUND=no
 	TARGETS+=$(BUILDDIR)/crded
-endif
-
-ifeq ($(strip $(SDLSOUND)),yes)
-	TARGETS+=$(BUILDDIR)/crx.sdl
 endif
 
 build-release:
@@ -190,25 +186,25 @@
 #############################################################################
 
 CODERED_OBJS = \
-	$(BUILDDIR)/client/cl_cin.o \
 	$(BUILDDIR)/client/cl_ents.o \
 	$(BUILDDIR)/client/cl_fx.o \
 	$(BUILDDIR)/client/cl_input.o \
 	$(BUILDDIR)/client/cl_inv.o \
+	$(BUILDDIR)/client/cl_irc.o \
 	$(BUILDDIR)/client/cl_main.o \
-	$(BUILDDIR)/client/cl_newfx.o \
 	$(BUILDDIR)/client/cl_parse.o \
 	$(BUILDDIR)/client/cl_pred.o \
 	$(BUILDDIR)/client/cl_tent.o \
 	$(BUILDDIR)/client/cl_scrn.o \
+	$(BUILDDIR)/client/cl_stats.o \
 	$(BUILDDIR)/client/cl_view.o \
 	$(BUILDDIR)/client/cl_http.o \
 	$(BUILDDIR)/client/console.o \
 	$(BUILDDIR)/client/keys.o \
 	$(BUILDDIR)/client/menu.o \
-	$(BUILDDIR)/client/snd_dma.o \
-	$(BUILDDIR)/client/snd_mem.o \
-	$(BUILDDIR)/client/snd_mix.o \
+	$(BUILDDIR)/client/snd_openal.o \
+	$(BUILDDIR)/client/snd_file.o \
+	$(BUILDDIR)/client/qal.o \
 	$(BUILDDIR)/client/qmenu.o \
 	\
 	$(BUILDDIR)/client/cmd.o \
@@ -236,6 +232,7 @@
 	$(BUILDDIR)/client/rw_unix.o \
 	$(BUILDDIR)/client/glob.o \
 	$(BUILDDIR)/client/net_udp.o \
+	$(BUILDDIR)/client/qal_unix.o \
 	\
 	$(BUILDDIR)/client/q_shared.o \
 	$(BUILDDIR)/client/pmove.o \
@@ -248,36 +245,26 @@
 	$(BUILDDIR)/ref_gl/r_mesh.o \
 	$(BUILDDIR)/ref_gl/r_misc.o \
 	$(BUILDDIR)/ref_gl/r_model.o \
-	$(BUILDDIR)/ref_gl/r_refl.o \
 	$(BUILDDIR)/ref_gl/r_math.o \
+	$(BUILDDIR)/ref_gl/r_particle.o \
+	$(BUILDDIR)/ref_gl/r_postprocess.o \
 	$(BUILDDIR)/ref_gl/r_script.o \
+	$(BUILDDIR)/ref_gl/r_shadowmaps.o \
+	$(BUILDDIR)/ref_gl/r_shadows.o \
 	$(BUILDDIR)/ref_gl/r_surf.o \
 	$(BUILDDIR)/ref_gl/r_vlights.o \
+	$(BUILDDIR)/ref_gl/r_varray.o \
+	$(BUILDDIR)/ref_gl/r_vbo.o \
 	$(BUILDDIR)/ref_gl/r_warp.o \
 	\
 	$(BUILDDIR)/ref_gl/qgl_unix.o
-
 
 REF_GL_GLX_OBJS = \
 	$(BUILDDIR)/ref_gl/gl_glx.o
 
-SOUND_OSS_OBJS = \
-	$(BUILDDIR)/client/snd_unix.o
-
-SOUND_SDL_OBJS = \
-	$(BUILDDIR)/client/snd_sdl.o
-
-CODERED_AS_OBJS = \
-	$(BUILDDIR)/client/snd_mixa.o
-
-$(BUILDDIR)/crx : $(CODERED_OBJS) $(SOUND_OSS_OBJS) $(CODERED_AS_OBJS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS)
-	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_OSS_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(CURLLDFLAGS) $(JPEGLDFLAGS)
-
-$(BUILDDIR)/crx.sdl : $(CODERED_OBJS) $(SOUND_SDL_OBJS) $(CODERED_AS_OBJS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS)
-	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(SOUND_SDL_OBJS) $(CODERED_AS_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(SDLLDFLAGS) $(CURLLDFLAGS) $(JPEGLDFLAGS)
-
-$(BUILDDIR)/client/cl_cin.o :     $(CLIENT_DIR)/cl_cin.c
-	$(DO_CC)
+
+$(BUILDDIR)/crx : $(CODERED_OBJS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS)
+	$(CC) $(CFLAGS) -o $@ $(CODERED_OBJS) $(LDFLAGS) $(REF_GL_OBJS) $(REF_GL_GLX_OBJS) $(GLXLDFLAGS) $(VORBISLDFLAGS) $(CURLLDFLAGS) $(JPEGLDFLAGS)
 
 $(BUILDDIR)/client/cl_ents.o :    $(CLIENT_DIR)/cl_ents.c
 	$(DO_CC)
@@ -290,13 +277,13 @@
 
 $(BUILDDIR)/client/cl_inv.o :     $(CLIENT_DIR)/cl_inv.c
 	$(DO_CC)
+	
+$(BUILDDIR)/client/cl_irc.o :     $(CLIENT_DIR)/cl_irc.c
+	$(DO_CC)
 
 $(BUILDDIR)/client/cl_main.o :    $(CLIENT_DIR)/cl_main.c
 	$(DO_CC)
 
-$(BUILDDIR)/client/cl_newfx.o :    $(CLIENT_DIR)/cl_newfx.c
-	$(DO_CC)
-
 $(BUILDDIR)/client/cl_parse.o :   $(CLIENT_DIR)/cl_parse.c
 	$(DO_CC)
 
@@ -308,6 +295,9 @@
 
 $(BUILDDIR)/client/cl_scrn.o :    $(CLIENT_DIR)/cl_scrn.c
 	$(DO_CC)
+	
+$(BUILDDIR)/client/cl_stats.o :    $(CLIENT_DIR)/cl_stats.c
+	$(DO_CC)
 
 $(BUILDDIR)/client/cl_view.o :    $(CLIENT_DIR)/cl_view.c
 	$(DO_CC)
@@ -319,16 +309,16 @@
 	$(DO_CC)
 
 $(BUILDDIR)/client/menu.o :       $(CLIENT_DIR)/menu.c
-	$(DO_CC)
-
-$(BUILDDIR)/client/snd_dma.o :    $(CLIENT_DIR)/snd_dma.c
-	$(DO_CC)
-
-$(BUILDDIR)/client/snd_mem.o :    $(CLIENT_DIR)/snd_mem.c
-	$(DO_CC)
-
-$(BUILDDIR)/client/snd_mix.o :    $(CLIENT_DIR)/snd_mix.c
-	$(DO_CC)
+	$(DO_CC) 
+	
+$(BUILDDIR)/client/snd_openal.o : $(CLIENT_DIR)/snd_openal.c
+	$(DO_CC) $(OPENALCFLAGS)
+
+$(BUILDDIR)/client/snd_file.o :    $(CLIENT_DIR)/snd_file.c
+	$(DO_CC) $(VORBISCFLAGS)
+
+$(BUILDDIR)/client/qal.o :        $(CLIENT_DIR)/qal.c
+	$(DO_CC) $(OPENALCFLAGS)
 
 $(BUILDDIR)/client/qmenu.o :      $(CLIENT_DIR)/qmenu.c
 	$(DO_CC)
@@ -358,7 +348,7 @@
 	$(DO_CC)
 
 $(BUILDDIR)/client/q_shared.o :   $(GAME_DIR)/q_shared.c
-	$(DO_DEBUG_CC)
+	$(DO_CC)
 
 $(BUILDDIR)/client/pmove.o :      $(COMMON_DIR)/pmove.c
 	$(DO_CC)
@@ -396,12 +386,6 @@
 $(BUILDDIR)/client/vid_so.o :     $(UNIX_DIR)/vid_so.c
 	$(DO_CC)
 
-$(BUILDDIR)/client/snd_unix.o :  $(UNIX_DIR)/snd_unix.c
-	$(DO_CC)
-
-$(BUILDDIR)/client/snd_mixa.o :   $(UNIX_DIR)/snd_mixa.s
-	$(DO_AS)
-
 $(BUILDDIR)/client/sys_unix.o :  $(UNIX_DIR)/sys_unix.c
 	$(DO_CC)
 
@@ -414,6 +398,9 @@
 $(BUILDDIR)/client/net_udp.o :    $(UNIX_DIR)/net_udp.c
 	$(DO_CC)
 
+$(BUILDDIR)/client/qal_unix.o :  $(UNIX_DIR)/qal_unix.c
+	$(DO_CC) $(OPENALCFLAGS)
+
 $(BUILDDIR)/client/cl_http.o :   $(CLIENT_DIR)/cl_http.c
 	$(DO_CC) $(CURLCFLAGS)
 
@@ -450,23 +437,34 @@
 $(BUILDDIR)/ref_gl/r_model.o :       $(REF_GL_DIR)/r_model.c
 	$(DO_GL_SHLIB_CC)
 
-$(BUILDDIR)/ref_gl/r_refl.o :       $(REF_GL_DIR)/r_refl.c
-	$(DO_GL_SHLIB_CC)
-
 $(BUILDDIR)/ref_gl/r_math.o :	    $(REF_GL_DIR)/r_math.c
 	$(DO_GL_SHLIB_CC)
+	
+$(BUILDDIR)/ref_gl/r_particle.o :	    $(REF_GL_DIR)/r_particle.c
+	$(DO_GL_SHLIB_CC)
+	
+$(BUILDDIR)/ref_gl/r_postprocess.o :	    $(REF_GL_DIR)/r_postprocess.c
+	$(DO_GL_SHLIB_CC)
+	
+$(BUILDDIR)/ref_gl/r_shadowmaps.o:     $(REF_GL_DIR)/r_shadowmaps.c
+	$(DO_GL_SHLIB_CC)
+	
+$(BUILDDIR)/ref_gl/r_shadows.o:     $(REF_GL_DIR)/r_shadows.c
+	$(DO_GL_SHLIB_CC)
 
 $(BUILDDIR)/ref_gl/r_vlights.o:     $(REF_GL_DIR)/r_vlights.c
 	$(DO_GL_SHLIB_CC)
 
+$(BUILDDIR)/ref_gl/r_varray.o:     $(REF_GL_DIR)/r_varray.c
+	$(DO_GL_SHLIB_CC)
+	
+$(BUILDDIR)/ref_gl/r_vbo.o:     $(REF_GL_DIR)/r_vbo.c
+	$(DO_GL_SHLIB_CC)
+
 $(BUILDDIR)/ref_gl/qgl_unix.o :      $(UNIX_DIR)/qgl_unix.c
 	$(DO_GL_SHLIB_CC)
 
 $(BUILDDIR)/ref_gl/gl_glx.o :      $(UNIX_DIR)/gl_glx.c
 	$(DO_GL_SHLIB_CC)
 
-$(BUILDDIR)/client/snd_sdl.o :     $(UNIX_DIR)/snd_sdl.c
-	$(DO_CC) $(SDLCFLAGS)
-
 #############################################################################
-# DEDICATED SERVER
