=== debian/changelog ===
alien-arena (7.33-2) unstable; urgency=low

  * Fix help text wrapping in launcher scripts (closes: #566633).
  * Depend on alien-arena-data (>= ${source:Upstream-Version}) to make
    the package NMU-safe (closes: #566636).

 -- Michael Gilbert <michael.s.gilbert@gmail.com>  Sun, 24 Jan 2010 14:42:07 -0500

alien-arena (7.33-1) unstable; urgency=high

  * New upstream release with many feature enhancments (closes: #592770).
    - Fixes CVE-2009-3637 remote arbitrary code execution (closes: #552038).
    - Server browser is now in-game.
    - This version is believed to address a couple very old crashes
      (closes: #467387, #437461).
  * Eliminated bashisms from launcher scripts (closes: #530040).
  * Add support for new upstream file naming scheme to watch file
    (closes: #513659).
  * Updated to use source format version 3.0.
  * Config directory has been moved to '~/.config/alien-arena' to adhere
    to the latest freedesktop standards.
  * Shared client/server files are now located in the alien-arena-common
    package.
  * Updated to standards version 3.8.3.

 -- Michael Gilbert <michael.s.gilbert@gmail.com>  Sun, 17 Jan 2010 16:56:23 -0500

alien-arena (7.0-1) unstable; urgency=low

  [ Barry deFreese ]
  * Escape - in alien-arena-server.6.
  * Add myself to uploaders.

  [ Ansgar Burchardt ]
  * Remove deprecated Encoding key from .desktop file.

  [ Gonéri Le Bouder ]
  * Remove Homepage from package description.

  [ Andres Mejia ]
  * New upstream release.
  * Removing XS- part for Vcs-* lines.
  * Removing +ssh part of Vcs-Svn line.
  * Bumped to Standards-Version 3.7.3.
  * Test for existence of *-stamp stamps before removing them.
  * Removed Encoding field in desktop file.
  * Modify patch for upstream Makefile to make Makefile more useful in building
    Debian packages.
    + Also fixes problem not detecting the existence of libcurl.
  * Remove debug packages for release. Will support nostrip option instead.
  * Add description for fix-CVE-2007-4754-CVE-2007-4755.dpatch, silences
    lintian warning.
  * Add new link for watchfile.
    + Closes: #453555
  * Moved debian/scripts/alien-arena-tarball.sh to
    debian/alien-arena-get-orig-source.
  * Modified alien-arena-data-get-orig-source to make it easier to maintain.
  * Switched from dpatch to quilt.
  * Cut down package description.
  * Closing bug about mouse constantly looking up. The submitter could not
    reproduce the bug after deleting the ~/.alien-arena directory.
    + Closes: #457700
  * Updated copyright file for new release.
  * Updated README.Debian files.
  * Adding new images for icons. Need build dependency on sharutils.

 -- Andres Mejia <mcitadel@gmail.com>  Fri, 18 Apr 2008 17:43:24 -0400

alien-arena (6.10-2) unstable; urgency=low

  [ Andres Mejia ]
  * Added notice about the use of the Quake II engine.
  * Took out notice about wrong file being released for version 6.05.

 -- Andres Mejia <mcitadel@gmail.com>  Tue, 13 Nov 2007 17:14:01 -0500

alien-arena (6.10-1) unstable; urgency=low

  [ Andres Mejia ]
  * New upstream release.
  * New dependency of libcurl4-gnutls-dev added to control file.
  * Homepage field added in control file.
  * XS-Vcs-Svn field fixed in control file.
  * Using new icon from upstream.
  * Modified fix-CVE-2007-4754-CVE-2007-4755 patch as some fixes were patched
    upstream.
  * Added tofrodos needed to patch a file.
  * Added dependency on libpng12-dev.
  * Added optional dependencies for libsdl, libjpeg, libgl, and libglu to make
    package more binNMU friendly.
  * Added package for ruby browser.
  * Adding script to generate orig tarball.

 -- Andres Mejia <mcitadel@gmail.com>  Sat, 10 Nov 2007 21:24:23 -0500

alien-arena (6.05-4.1) unstable; urgency=high

  * Non-maintainer upload by testing security team.
  * Included fix-CVE-2007-4754-CVE-2007-4755.dpatch to
    fix format string vulnerability and possible denial of service
    via client_connect (CVE-2007-4754, CVE-2007-4755) (Closes: #442075).

 -- Nico Golde <nion@debian.org>  Sat, 15 Sep 2007 02:39:15 +0200

alien-arena (6.05-4) unstable; urgency=low

  [ Andres Mejia ]
  * Addressing lintian debian-rules-ignores-make-clean-error warning.

 -- Andres Mejia <mcitadel@gmail.com>  Thu, 16 Aug 2007 17:55:12 -0400

alien-arena (6.05-3) unstable; urgency=low

  [ Linas Žvirblis ]
  * update menu section to "Games/Action" for menu policy transition.

  [ Cyril Brulebois ]
  * Added XS-Vcs-Svn and XS-Vcs-Browser fields in the control file.

 -- Andres Mejia <mcitadel@gmail.com>  Sun, 12 Aug 2007 12:18:24 -0400

alien-arena (6.05-2) unstable; urgency=low

  * Changing scripts to use "echo -e" instead of just "echo".
    + Fixes help text formatting. (Closes: #436928)

 -- Andres Mejia <mcitadel@gmail.com>  Thu, 09 Aug 2007 22:42:01 -0400

alien-arena (6.05-1) unstable; urgency=low

  * Initial packaging (closes: bug#424951)

 -- Andres Mejia <mcitadel@gmail.com>  Thu, 14 Jun 2007 19:44:45 -0400
